signature Abs_theory =
sig

  type hol_type = Type.hol_type
  type term = Term.term
  type thm = Thm.thm
  type goal = Abbrev.goal
  type tactic = Abbrev.tactic
  type conv = Abbrev.conv
  type thm_tactic = Abbrev.thm_tactic

  val theory_obligs: ((string * {oblig: thm, rep_defs: thm list}) list) ref

  val new_abstract_entity: {Name: string, Predicate: term} -> thm

  val abs_convert_term: term -> term

  val ag:            term frag list -> GoalstackPure.proofs
  val abs_set_goal:  goal -> GoalstackPure.proofs
  val abs_prove:     term * tactic -> thm
  val abs_store_thm: string * term * tactic -> thm

  val EXPAND_THOBS_CONV: conv
  val EXPAND_THOBS_TAC:  tactic
  val EXPAND_THOBS_RULE: thm -> thm
  val STRIP_THOBS_THEN:  thm_tactic -> thm_tactic -> tactic
  val STRIP_THOBS_TAC:   tactic

  val get_obligs:            string -> thm list
  val get_abs_reps:          string -> thm list
  val add_obligs:            string -> unit

  val instantiate_abs_thm: {abs_term: term,
                            rep_term: term,
                            validation: thm} list
                           -> thm -> thm
  val instantiate_abstract_definition: {abs_term: term, rep_term: term} list
                                       -> thm -> thm -> thm
end;

