signature Imp_rewrite =
sig
   type hol_type = Type.hol_type
   type term = Term.term
   type thm = Thm.thm
   type conv = Abbrev.conv
   type tactic = Abbrev.tactic

val mk_imp_conv_net : thm list -> (term list -> conv) Net.net
val IMP_REWRITES_CONV : term list -> (term list -> conv) Net.net -> conv
val basic_imp_rewrites : (term list -> conv) Net.net ref
val GEN_IMP_REWRITE_CONV : (conv -> conv) -> (term list -> conv) Net.net ref
                            -> thm list -> term list -> conv
val PURE_IMP_REWRITE_CONV : thm list -> term list -> conv
val IMP_REWRITE_CONV : thm list -> term list -> conv
val PURE_ONCE_IMP_REWRITE_CONV : thm list -> term list -> conv
val ONCE_IMP_REWRITE_CONV : thm list -> term list -> conv
val GEN_IMP_REWRITE_RULE : (conv -> conv) -> (term list -> conv) Net.net ref
                            ->  thm list -> thm -> thm
val GEN_IMP_REWRITE_TAC : (conv -> conv) -> (term list -> conv) Net.net ref
                            -> thm list -> tactic
val PURE_IMP_REWRITE_RULE : thm list -> thm -> thm
val IMP_REWRITE_RULE : thm list -> thm -> thm
val PURE_ONCE_IMP_REWRITE_RULE : thm list -> thm -> thm
val ONCE_IMP_REWRITE_RULE : thm list -> thm -> thm
val PURE_ASM_IMP_REWRITE_RULE : thm list -> thm -> thm
val ASM_IMP_REWRITE_RULE : thm list -> thm -> thm
val PURE_ONCE_ASM_IMP_REWRITE_RULE : thm list -> thm -> thm
val ONCE_ASM_IMP_REWRITE_RULE : thm list -> thm -> thm
val PURE_IMP_REWRITE_TAC : thm list -> tactic
val IMP_REWRITE_TAC : thm list -> tactic
val PURE_ONCE_IMP_REWRITE_TAC : thm list -> tactic
val ONCE_IMP_REWRITE_TAC : thm list -> tactic
val PURE_ASM_IMP_REWRITE_TAC : thm list -> tactic
val ASM_IMP_REWRITE_TAC : thm list -> tactic
val PURE_ONCE_ASM_IMP_REWRITE_TAC : thm list -> tactic
val ONCE_ASM_IMP_REWRITE_TAC : thm list -> tactic
val FILTER_PURE_ASM_IMP_REWRITE_RULE :(term -> bool) -> thm list -> thm -> thm
val FILTER_ASM_IMP_REWRITE_RULE :(term -> bool) -> thm list -> thm -> thm
val FILTER_PURE_ONCE_ASM_IMP_REWRITE_RULE :(term -> bool) -> thm list 
                                            -> thm -> thm
val FILTER_ONCE_ASM_IMP_REWRITE_RULE :(term -> bool)
                                       -> thm list -> thm -> thm
val FILTER_PURE_ASM_IMP_REWRITE_TAC :(term -> bool) -> thm list -> tactic
val FILTER_ASM_IMP_REWRITE_TAC :(term -> bool) -> thm list -> tactic
val FILTER_PURE_ONCE_ASM_IMP_REWRITE_TAC :(term -> bool) 
                                            -> thm list -> tactic
val FILTER_ONCE_ASM_IMP_REWRITE_TAC :(term -> bool) -> thm list -> tactic

end;

