signature groupTheory =
sig
  type thm = Thm.thm
  
  (*  Definitions  *)
    val fn_abs_rep : thm
    val group_DEF : thm
    val group_ISO_DEF : thm
    val group_TY_DEF : thm
    val group_oblig : thm
    val group_sq : thm
    val id_abs_rep : thm
    val inv_abs_rep : thm
  
  (*  Theorems  *)
    val IDENTITY_UNIQUE : thm
    val INVERSE_INVERSE_LEMMA : thm
    val LEFT_CANCELLATION : thm
    val OP_DETERMINES_IDENTITY : thm
    val group : thm
(*
   [monoid] Parent theory of "group"
   
   [fn_abs_rep]
   Definition
   [oracles: num_CONV] [axioms: ] [] |- !fn id inv. fn (group inv id fn) = fn
   
   [group_DEF]
   Definition
   [oracles: ] [axioms: ] []
   |- !f0 x f1. group f0 x f1 = ABS_group (Node (f0,x,f1) [])
   
   [group_ISO_DEF]
   Definition
   [oracles: num_CONV] [axioms: ] []
   |- (!a. ABS_group (REP_group a) = a) /\
      (!r.
        TRP (\v tl. (?f0 x f1. v = (f0,x,f1)) /\ (LENGTH tl = 0)) r =
        REP_group (ABS_group r) =
        r)
   
   [group_TY_DEF]
   Definition
   [oracles: num_CONV] [axioms: ] []
   |- ?rep.
        TYPE_DEFINITION
          (TRP (\v tl. (?f0 x f1. v = (f0,x,f1)) /\ (LENGTH tl = 0)))
          rep
   
   [group_oblig]
   Definition
   [oracles: ] [axioms: ] []
   |- !g.
        group_oblig g =
        (!x. fn g x (id g) = x) /\
        (!x. fn g (id g) x = x) /\
        (!x. fn g x (inv g x) = id g) /\
        (!x. fn g (inv g x) x = id g) /\
        (!x y z. fn g x (fn g y z) = fn g (fn g x y) z)
   
   [group_sq]
   Definition
   [oracles: ] [axioms: ] []
   |- !g a. group_sq g a = monoid_sq (monoid (id g) (fn g)) a
   
   [id_abs_rep]
   Definition
   [oracles: num_CONV] [axioms: ] [] |- !fn id inv. id (group inv id fn) = id
   
   [inv_abs_rep]
   Definition
   [oracles: num_CONV] [axioms: ] []
   |- !fn id inv. inv (group inv id fn) = inv
   
   [IDENTITY_UNIQUE]
   Theorem
   [oracles: num_CONV] [axioms: ] []
   |- !g.
        group_oblig g ==>
        (!f. (!a. (fn g a f = a) /\ (fn g f a = a)) ==> (f = id g))
   
   [INVERSE_INVERSE_LEMMA]
   Theorem
   [oracles: ] [axioms: ] []
   |- !g. group_oblig g ==> (!a. inv g (inv g a) = a)
   
   [LEFT_CANCELLATION]
   Theorem
   [oracles: ] [axioms: ] []
   |- !g. group_oblig g ==> (!x y a. (fn g a x = fn g a y) ==> (x = y))
   
   [OP_DETERMINES_IDENTITY]
   Theorem
   [oracles: num_CONV] [axioms: ] []
   |- !g2 g1.
        group_oblig g1 /\ group_oblig g2 ==>
        (fn g1 = fn g2) ==>
        (id g1 = id g2)
   
   [group]
   Theorem
   [oracles: num_CONV] [axioms: ] []
   |- !f. ?!fn. !f0 x f1. fn (group f0 x f1) = f f0 x f1
   
   
*)
end
