structure groupTheory :> groupTheory =
struct
  type thm = Thm.thm
  val pty = Parse.type_parser
  fun C s q = Term.mk_const{Name=s,Ty=pty q}
  fun V s q = Term.mk_var{Name=s,Ty=pty q}
  
  (*  Parents *)
  local open monoidTheory
  in end;
  val _ = Theory.link_parents
          ("group",930562642,37014)
          [("monoid",930562542,882390)];
  val _ = Theory.incorporate_types "group" [("group",1)];
  val _ = Theory.incorporate_consts "group"
     [("group_oblig",pty`:'a group -> bool`,Term.Prefix),
      ("group",pty`:('a -> 'a) -> 'a -> ('a -> 'a -> 'a) -> 'a group`,
       Term.Prefix), ("inv",pty`:'a group -> 'a -> 'a`,Term.Prefix),
      ("fn",pty`:'a group -> 'a -> 'a -> 'a`,Term.Prefix),
      ("id",pty`:'a group -> 'a`,Term.Prefix),
      ("group_sq",pty`:'a group -> 'a -> 'a`,Term.Prefix),
      ("REP_group",
       pty`:'a group -> (('a -> 'a) # 'a # ('a -> 'a -> 'a)) ltree`,
       Term.Prefix),
      ("ABS_group",
       pty`:(('a -> 'a) # 'a # ('a -> 'a -> 'a)) ltree -> 'a group`,
       Term.Prefix)];
  
  local
  val share_table = Vector.fromList
  [C "?"
     `:(('a group -> (('a -> 'a) # 'a # ('a -> 'a -> 'a)) ltree) -> bool) ->
       bool`,
   V "rep" `:'a group -> (('a -> 'a) # 'a # ('a -> 'a -> 'a)) ltree`,
   C "TYPE_DEFINITION"
     `:((('a -> 'a) # 'a # ('a -> 'a -> 'a)) ltree -> bool) ->
       ('a group -> (('a -> 'a) # 'a # ('a -> 'a -> 'a)) ltree) -> bool`,
   C "TRP"
     `:(('a -> 'a) # 'a # ('a -> 'a -> 'a) ->
       (('a -> 'a) # 'a # ('a -> 'a -> 'a)) ltree list -> bool) ->
       (('a -> 'a) # 'a # ('a -> 'a -> 'a)) ltree -> bool`,
   V "v" `:('a -> 'a) # 'a # ('a -> 'a -> 'a)`,
   V "tl" `:(('a -> 'a) # 'a # ('a -> 'a -> 'a)) ltree list`,
   C "/\\" `:bool -> bool -> bool`, C "?" `:(('a -> 'a) -> bool) -> bool`,
   V "f0" `:'a -> 'a`, C "?" `:('a -> bool) -> bool`, V "x" `:'a`,
   C "?" `:(('a -> 'a -> 'a) -> bool) -> bool`, V "f1" `:'a -> 'a -> 'a`,
   C "="
     `:('a -> 'a) # 'a # ('a -> 'a -> 'a) ->
       ('a -> 'a) # 'a # ('a -> 'a -> 'a) -> bool`,
   C ","
     `:('a -> 'a) -> 'a # ('a -> 'a -> 'a) ->
       ('a -> 'a) # 'a # ('a -> 'a -> 'a)`,
   C "," `:'a -> ('a -> 'a -> 'a) -> 'a # ('a -> 'a -> 'a)`,
   C "=" `:num -> num -> bool`,
   C "LENGTH" `:(('a -> 'a) # 'a # ('a -> 'a -> 'a)) ltree list -> num`,
   C "0" `:num`, C "!" `:('a group -> bool) -> bool`, V "a" `:'a group`,
   C "=" `:'a group -> 'a group -> bool`,
   C "ABS_group" `:(('a -> 'a) # 'a # ('a -> 'a -> 'a)) ltree -> 'a group`,
   C "REP_group" `:'a group -> (('a -> 'a) # 'a # ('a -> 'a -> 'a)) ltree`,
   C "!" `:((('a -> 'a) # 'a # ('a -> 'a -> 'a)) ltree -> bool) -> bool`,
   V "r" `:(('a -> 'a) # 'a # ('a -> 'a -> 'a)) ltree`,
   C "=" `:bool -> bool -> bool`,
   C "="
     `:(('a -> 'a) # 'a # ('a -> 'a -> 'a)) ltree ->
       (('a -> 'a) # 'a # ('a -> 'a -> 'a)) ltree -> bool`,
   C "!" `:(('a -> 'a) -> bool) -> bool`, C "!" `:('a -> bool) -> bool`,
   C "!" `:(('a -> 'a -> 'a) -> bool) -> bool`,
   C "group" `:('a -> 'a) -> 'a -> ('a -> 'a -> 'a) -> 'a group`,
   C "Node"
     `:('a -> 'a) # 'a # ('a -> 'a -> 'a) ->
       (('a -> 'a) # 'a # ('a -> 'a -> 'a)) ltree list ->
       (('a -> 'a) # 'a # ('a -> 'a -> 'a)) ltree`,
   C "NIL" `:(('a -> 'a) # 'a # ('a -> 'a -> 'a)) ltree list`,
   V "fn" `:'a -> 'a -> 'a`, V "id" `:'a`, V "inv" `:'a -> 'a`,
   C "=" `:('a -> 'a) -> ('a -> 'a) -> bool`, C "inv" `:'a group -> 'a -> 'a`,
   C "=" `:'a -> 'a -> bool`, C "id" `:'a group -> 'a`,
   C "=" `:('a -> 'a -> 'a) -> ('a -> 'a -> 'a) -> bool`,
   C "fn" `:'a group -> 'a -> 'a -> 'a`, V "g" `:'a group`,
   C "group_oblig" `:'a group -> bool`, V "y" `:'a`, V "z" `:'a`, V "a" `:'a`,
   C "group_sq" `:'a group -> 'a -> 'a`,
   C "monoid_sq" `:'a monoid -> 'a -> 'a`,
   C "monoid" `:'a -> ('a -> 'a -> 'a) -> 'a monoid`,
   C "!" `:((('a -> 'a) -> 'a -> ('a -> 'a -> 'a) -> 'a1) -> bool) -> bool`,
   V "f" `:('a -> 'a) -> 'a -> ('a -> 'a -> 'a) -> 'a1`,
   C "?!" `:(('a group -> 'a1) -> bool) -> bool`, V "fn" `:'a group -> 'a1`,
   C "=" `:'a1 -> 'a1 -> bool`, C "==>" `:bool -> bool -> bool`, V "f" `:'a`,
   V "g2" `:'a group`, V "g1" `:'a group`]
  val DT = Thm.disk_thm share_table
  in
  val group_TY_DEF =
    DT("num_CONV", [],
       `(%0 (\%1. ((%2 (%3 (\%4. (\%5. ((%6 (%7 (\%8. (%9 (\%10. (%11 (\%12.
       ((%13 $4) ((%14 $2) ((%15 $1) $0)))))))))) ((%16 (%17 $0)) %18))))))
       $0)))`)
  val group_ISO_DEF =
    DT("num_CONV", [],
       `((%6 (%19 (\%20. ((%21 (%22 (%23 $0))) $0)))) (%24 (\%25. ((%26 ((%3
       (\%4. (\%5. ((%6 (%7 (\%8. (%9 (\%10. (%11 (\%12. ((%13 $4) ((%14 $2)
       ((%15 $1) $0)))))))))) ((%16 (%17 $0)) %18))))) $0)) ((%27 (%23 (%22
       $0))) $0)))))`)
  val group_DEF =
    DT("", [],
       `(%28 (\%8. (%29 (\%10. (%30 (\%12. ((%21 (((%31 $2) $1) $0)) (%22
       ((%32 ((%14 $2) ((%15 $1) $0))) %33)))))))))`)
  val inv_abs_rep =
    DT("num_CONV", [],
       `(%30 (\%34. (%29 (\%35. (%28 (\%36. ((%37 (%38 (((%31 $0) $1) $2)))
       $0)))))))`)
  val id_abs_rep =
    DT("num_CONV", [],
       `(%30 (\%34. (%29 (\%35. (%28 (\%36. ((%39 (%40 (((%31 $0) $1) $2)))
       $1)))))))`)
  val fn_abs_rep =
    DT("num_CONV", [],
       `(%30 (\%34. (%29 (\%35. (%28 (\%36. ((%41 (%42 (((%31 $0) $1) $2)))
       $2)))))))`)
  val group_oblig =
    DT("", [],
       `(%19 (\%43. ((%26 (%44 $0)) ((%6 (%29 (\%10. ((%39 (((%42 $1) $0) (%40
       $1))) $0)))) ((%6 (%29 (\%10. ((%39 (((%42 $1) (%40 $1)) $0)) $0))))
       ((%6 (%29 (\%10. ((%39 (((%42 $1) $0) ((%38 $1) $0))) (%40 $1))))) ((%6
       (%29 (\%10. ((%39 (((%42 $1) ((%38 $1) $0)) $0)) (%40 $1))))) (%29
       (\%10. (%29 (\%45. (%29 (\%46. ((%39 (((%42 $3) $2) (((%42 $3) $1)
       $0))) (((%42 $3) (((%42 $3) $2) $1)) $0)))))))))))))))`)
  val group_sq =
    DT("", [],
       `(%19 (\%43. (%29 (\%47. ((%39 ((%48 $1) $0)) ((%49 ((%50 (%40 $1))
       (%42 $1))) $0))))))`)
  val group =
    DT("num_CONV", [],
       `(%51 (\%52. (%53 (\%54. (%28 (\%8. (%29 (\%10. (%30 (\%12. ((%55 ($3
       (((%31 $2) $1) $0))) ((($4 $2) $1) $0))))))))))))`)
  val IDENTITY_UNIQUE =
    DT("num_CONV", [],
       `(%19 (\%43. ((%56 (%44 $0)) (%29 (\%57. ((%56 (%29 (\%47. ((%6 ((%39
       (((%42 $2) $0) $1)) $0)) ((%39 (((%42 $2) $1) $0)) $0))))) ((%39 $0)
       (%40 $1))))))))`)
  val OP_DETERMINES_IDENTITY =
    DT("num_CONV", [],
       `(%19 (\%58. (%19 (\%59. ((%56 ((%6 (%44 $0)) (%44 $1))) ((%56 ((%41
       (%42 $0)) (%42 $1))) ((%39 (%40 $0)) (%40 $1))))))))`)
  val LEFT_CANCELLATION =
    DT("", [],
       `(%19 (\%43. ((%56 (%44 $0)) (%29 (\%10. (%29 (\%45. (%29 (\%47. ((%56
       ((%39 (((%42 $3) $0) $2)) (((%42 $3) $0) $1))) ((%39 $2)
       $1)))))))))))`)
  val INVERSE_INVERSE_LEMMA =
    DT("", [],
       `(%19 (\%43. ((%56 (%44 $0)) (%29 (\%47. ((%39 ((%38 $1) ((%38 $1)
       $0))) $0))))))`)
  end
  val _ = DB.bindl "group"
  [("group_TY_DEF",group_TY_DEF,DB.Def),
   ("group_ISO_DEF",group_ISO_DEF,DB.Def), ("group_DEF",group_DEF,DB.Def),
   ("inv_abs_rep",inv_abs_rep,DB.Def), ("id_abs_rep",id_abs_rep,DB.Def),
   ("fn_abs_rep",fn_abs_rep,DB.Def), ("group_oblig",group_oblig,DB.Def),
   ("group_sq",group_sq,DB.Def), ("group",group,DB.Thm),
   ("IDENTITY_UNIQUE",IDENTITY_UNIQUE,DB.Thm),
   ("OP_DETERMINES_IDENTITY",OP_DETERMINES_IDENTITY,DB.Thm),
   ("LEFT_CANCELLATION",LEFT_CANCELLATION,DB.Thm),
   ("INVERSE_INVERSE_LEMMA",INVERSE_INVERSE_LEMMA,DB.Thm)]
  
  
end
