signature monoidTheory =
sig
  type thm = Thm.thm
  
  (*  Definitions  *)
    val e_abs_rep : thm
    val monoid_DEF : thm
    val monoid_ISO_DEF : thm
    val monoid_TY_DEF : thm
    val monoid_oblig : thm
    val monoid_sq : thm
    val op_abs_rep : thm
  
  (*  Theorems  *)
    val IDENTITY_UNIQUE : thm
    val OP_DETERMINES_IDENTITY : thm
    val monoid : thm
(*
   [one] Parent theory of "monoid"
   
   [rec_type] Parent theory of "monoid"
   
   [sum] Parent theory of "monoid"
   
   [e_abs_rep]
   Definition
   [oracles: num_CONV] [axioms: ] [] |- !op e. e (monoid e op) = e
   
   [monoid_DEF]
   Definition
   [oracles: ] [axioms: ] []
   |- !x f'. monoid x f' = ABS_monoid (Node (x,f') [])
   
   [monoid_ISO_DEF]
   Definition
   [oracles: num_CONV] [axioms: ] []
   |- (!a. ABS_monoid (REP_monoid a) = a) /\
      (!r.
        TRP (\v tl. (?x f. v = (x,f)) /\ (LENGTH tl = 0)) r =
        REP_monoid (ABS_monoid r) =
        r)
   
   [monoid_TY_DEF]
   Definition
   [oracles: num_CONV] [axioms: ] []
   |- ?rep.
        TYPE_DEFINITION (TRP (\v tl. (?x f. v = (x,f)) /\ (LENGTH tl = 0)))
          rep
   
   [monoid_oblig]
   Definition
   [oracles: ] [axioms: ] []
   |- !m.
        monoid_oblig m =
        (!x. op m x (e m) = x) /\
        (!x. op m (e m) x = x) /\
        (!x y z. op m x (op m y z) = op m (op m x y) z)
   
   [monoid_sq]
   Definition
   [oracles: ] [axioms: ] [] |- !m a. monoid_sq m a = op m a a
   
   [op_abs_rep]
   Definition
   [oracles: num_CONV] [axioms: ] [] |- !op e. op (monoid e op) = op
   
   [IDENTITY_UNIQUE]
   Theorem
   [oracles: ] [axioms: ] []
   |- !m.
        monoid_oblig m ==>
        (!f. (!a. (op m a f = a) /\ (op m f a = a)) ==> (f = e m))
   
   [OP_DETERMINES_IDENTITY]
   Theorem
   [oracles: ] [axioms: ] []
   |- !m1 m2.
        monoid_oblig m1 /\ monoid_oblig m2 ==>
        (op m1 = op m2) ==>
        (e m1 = e m2)
   
   [monoid]
   Theorem
   [oracles: num_CONV] [axioms: ] []
   |- !f. ?!fn. !x f'. fn (monoid x f') = f x f'
   
   
*)
end
