structure monoidTheory :> monoidTheory =
struct
  type thm = Thm.thm
  val pty = Parse.type_parser
  fun C s q = Term.mk_const{Name=s,Ty=pty q}
  fun V s q = Term.mk_var{Name=s,Ty=pty q}
  
  (*  Parents *)
  local open oneTheory rec_typeTheory sumTheory
  in end;
  val _ = Theory.link_parents
          ("monoid",930562542,882390)
          [("one",918563758,860481), ("rec_type",918564028,960064),
           ("sum",918563673,121265)];
  val _ = Theory.incorporate_types "monoid" [("monoid",1)];
  val _ = Theory.incorporate_consts "monoid"
     [("e",pty`:'a monoid -> 'a`,Term.Prefix),
      ("monoid_sq",pty`:'a monoid -> 'a -> 'a`,Term.Prefix),
      ("op",pty`:'a monoid -> 'a -> 'a -> 'a`,Term.Prefix),
      ("ABS_monoid",pty`:('a # ('a -> 'a -> 'a)) ltree -> 'a monoid`,
       Term.Prefix),
      ("REP_monoid",pty`:'a monoid -> ('a # ('a -> 'a -> 'a)) ltree`,
       Term.Prefix),
      ("monoid",pty`:'a -> ('a -> 'a -> 'a) -> 'a monoid`,Term.Prefix),
      ("monoid_oblig",pty`:'a monoid -> bool`,Term.Prefix)];
  
  local
  val share_table = Vector.fromList
  [C "?" `:(('a monoid -> ('a # ('a -> 'a -> 'a)) ltree) -> bool) -> bool`,
   V "rep" `:'a monoid -> ('a # ('a -> 'a -> 'a)) ltree`,
   C "TYPE_DEFINITION"
     `:(('a # ('a -> 'a -> 'a)) ltree -> bool) ->
       ('a monoid -> ('a # ('a -> 'a -> 'a)) ltree) -> bool`,
   C "TRP"
     `:('a # ('a -> 'a -> 'a) -> ('a # ('a -> 'a -> 'a)) ltree list ->
       bool) -> ('a # ('a -> 'a -> 'a)) ltree -> bool`,
   V "v" `:'a # ('a -> 'a -> 'a)`,
   V "tl" `:('a # ('a -> 'a -> 'a)) ltree list`,
   C "/\\" `:bool -> bool -> bool`, C "?" `:('a -> bool) -> bool`,
   V "x" `:'a`, C "?" `:(('a -> 'a -> 'a) -> bool) -> bool`,
   V "f" `:'a -> 'a -> 'a`,
   C "=" `:'a # ('a -> 'a -> 'a) -> 'a # ('a -> 'a -> 'a) -> bool`,
   C "," `:'a -> ('a -> 'a -> 'a) -> 'a # ('a -> 'a -> 'a)`,
   C "=" `:num -> num -> bool`,
   C "LENGTH" `:('a # ('a -> 'a -> 'a)) ltree list -> num`, C "0" `:num`,
   C "!" `:('a monoid -> bool) -> bool`, V "a" `:'a monoid`,
   C "=" `:'a monoid -> 'a monoid -> bool`,
   C "ABS_monoid" `:('a # ('a -> 'a -> 'a)) ltree -> 'a monoid`,
   C "REP_monoid" `:'a monoid -> ('a # ('a -> 'a -> 'a)) ltree`,
   C "!" `:(('a # ('a -> 'a -> 'a)) ltree -> bool) -> bool`,
   V "r" `:('a # ('a -> 'a -> 'a)) ltree`, C "=" `:bool -> bool -> bool`,
   C "="
     `:('a # ('a -> 'a -> 'a)) ltree -> ('a # ('a -> 'a -> 'a)) ltree ->
       bool`, C "!" `:('a -> bool) -> bool`,
   C "!" `:(('a -> 'a -> 'a) -> bool) -> bool`, V "f'" `:'a -> 'a -> 'a`,
   C "monoid" `:'a -> ('a -> 'a -> 'a) -> 'a monoid`,
   C "Node"
     `:'a # ('a -> 'a -> 'a) -> ('a # ('a -> 'a -> 'a)) ltree list ->
       ('a # ('a -> 'a -> 'a)) ltree`,
   C "NIL" `:('a # ('a -> 'a -> 'a)) ltree list`, V "op" `:'a -> 'a -> 'a`,
   V "e" `:'a`, C "=" `:'a -> 'a -> bool`, C "e" `:'a monoid -> 'a`,
   C "=" `:('a -> 'a -> 'a) -> ('a -> 'a -> 'a) -> bool`,
   C "op" `:'a monoid -> 'a -> 'a -> 'a`, V "m" `:'a monoid`,
   C "monoid_oblig" `:'a monoid -> bool`, V "y" `:'a`, V "z" `:'a`,
   V "a" `:'a`, C "monoid_sq" `:'a monoid -> 'a -> 'a`,
   C "!" `:(('a -> ('a -> 'a -> 'a) -> 'a1) -> bool) -> bool`,
   V "f" `:'a -> ('a -> 'a -> 'a) -> 'a1`,
   C "?!" `:(('a monoid -> 'a1) -> bool) -> bool`, V "fn" `:'a monoid -> 'a1`,
   C "=" `:'a1 -> 'a1 -> bool`, C "==>" `:bool -> bool -> bool`, V "f" `:'a`,
   V "m1" `:'a monoid`, V "m2" `:'a monoid`]
  val DT = Thm.disk_thm share_table
  in
  val monoid_TY_DEF =
    DT("num_CONV", [],
       `(%0 (\%1. ((%2 (%3 (\%4. (\%5. ((%6 (%7 (\%8. (%9 (\%10. ((%11 $3)
       ((%12 $1) $0))))))) ((%13 (%14 $0)) %15)))))) $0)))`)
  val monoid_ISO_DEF =
    DT("num_CONV", [],
       `((%6 (%16 (\%17. ((%18 (%19 (%20 $0))) $0)))) (%21 (\%22. ((%23 ((%3
       (\%4. (\%5. ((%6 (%7 (\%8. (%9 (\%10. ((%11 $3) ((%12 $1) $0)))))))
       ((%13 (%14 $0)) %15))))) $0)) ((%24 (%20 (%19 $0))) $0)))))`)
  val monoid_DEF =
    DT("", [],
       `(%25 (\%8. (%26 (\%27. ((%18 ((%28 $1) $0)) (%19 ((%29 ((%12 $1) $0))
       %30)))))))`)
  val e_abs_rep =
    DT("num_CONV", [],
       `(%26 (\%31. (%25 (\%32. ((%33 (%34 ((%28 $0) $1))) $0)))))`)
  val op_abs_rep =
    DT("num_CONV", [],
       `(%26 (\%31. (%25 (\%32. ((%35 (%36 ((%28 $0) $1))) $1)))))`)
  val monoid_oblig =
    DT("", [],
       `(%16 (\%37. ((%23 (%38 $0)) ((%6 (%25 (\%8. ((%33 (((%36 $1) $0) (%34
       $1))) $0)))) ((%6 (%25 (\%8. ((%33 (((%36 $1) (%34 $1)) $0)) $0))))
       (%25 (\%8. (%25 (\%39. (%25 (\%40. ((%33 (((%36 $3) $2) (((%36 $3) $1)
       $0))) (((%36 $3) (((%36 $3) $2) $1)) $0)))))))))))))`)
  val monoid_sq =
    DT("", [],
       `(%16 (\%37. (%25 (\%41. ((%33 ((%42 $1) $0)) (((%36 $1) $0) $0))))))`)
  val monoid =
    DT("num_CONV", [],
       `(%43 (\%44. (%45 (\%46. (%25 (\%8. (%26 (\%27. ((%47 ($2 ((%28 $1)
       $0))) (($3 $1) $0))))))))))`)
  val IDENTITY_UNIQUE =
    DT("", [],
       `(%16 (\%37. ((%48 (%38 $0)) (%25 (\%49. ((%48 (%25 (\%41. ((%6 ((%33
       (((%36 $2) $0) $1)) $0)) ((%33 (((%36 $2) $1) $0)) $0))))) ((%33 $0)
       (%34 $1))))))))`)
  val OP_DETERMINES_IDENTITY =
    DT("", [],
       `(%16 (\%50. (%16 (\%51. ((%48 ((%6 (%38 $1)) (%38 $0))) ((%48 ((%35
       (%36 $1)) (%36 $0))) ((%33 (%34 $1)) (%34 $0))))))))`)
  end
  val _ = DB.bindl "monoid"
  [("monoid_TY_DEF",monoid_TY_DEF,DB.Def),
   ("monoid_ISO_DEF",monoid_ISO_DEF,DB.Def), ("monoid_DEF",monoid_DEF,DB.Def),
   ("e_abs_rep",e_abs_rep,DB.Def), ("op_abs_rep",op_abs_rep,DB.Def),
   ("monoid_oblig",monoid_oblig,DB.Def), ("monoid_sq",monoid_sq,DB.Def),
   ("monoid",monoid,DB.Thm), ("IDENTITY_UNIQUE",IDENTITY_UNIQUE,DB.Thm),
   ("OP_DETERMINES_IDENTITY",OP_DETERMINES_IDENTITY,DB.Thm)]
  
  
end
