load "abs_theoryLib";
open abs_theoryLib;

new_theory"xor";

load "groupTheory";

add_obligs "group";

val exclusive_or = new_infix_definition
("exclusive_or",
  --`! (x:bool) y. $>< x y = ~(x=y)`--, 20);


val exorgroup =
  prove((--`group_oblig(group I F ($><))`--),
        EXPAND_THOBS_TAC
        THEN REWRITE_TAC[exclusive_or,combinTheory.I_THM]
        THEN (REPEAT GEN_TAC
              THEN MAP_EVERY BOOL_CASES_TAC [--`x:bool`--,
                                             --`y:bool`--,
                                             --`z:bool`--]
              THEN REWRITE_TAC[]));


val EXOR_IDENTITY_UNIQUE =
    instantiate_abs_thm [{abs_term=(--`g:('a)group`--),
                          rep_term=(--`group I F ($><)`--),
                          validation=exorgroup}]
                        groupTheory.IDENTITY_UNIQUE;

val EXOR_GROUP_ID =       
    instantiate_abs_thm [{abs_term=(--`g2:('a)group`--),
                          rep_term=(--`group I F ($><)`--),
                          validation=exorgroup}]
                        groupTheory.OP_DETERMINES_IDENTITY;

val EXOR_LEFT_CANCELLATION =
    instantiate_abs_thm [{abs_term=(--`g:('a)group`--),
                          rep_term=(--`group I F ($><)`--),
                          validation=exorgroup}]
                        groupTheory.LEFT_CANCELLATION;
    
val EXOR_INVERSE_INVERSE_LEMMA =
    instantiate_abs_thm [{abs_term=(--`g:('a)group`--),
                          rep_term=(--`group I F ($><)`--),
                          validation=exorgroup}]
                        groupTheory.INVERSE_INVERSE_LEMMA;

val _ = export_theory();
