structure xorTheory :> xorTheory =
struct
  type thm = Thm.thm
  val pty = Parse.type_parser
  fun C s q = Term.mk_const{Name=s,Ty=pty q}
  fun V s q = Term.mk_var{Name=s,Ty=pty q}
  
  (*  Parents *)
  local open groupTheory
  in end;
  val _ = Theory.link_parents
          ("xor",930562717,355196)
          [("group",930562642,37014)];
  val _ = Theory.incorporate_types "xor" [];
  val _ = Theory.incorporate_consts "xor"
     [("><",pty`:bool -> bool -> bool`,Term.Infix 20)];
  
  local
  val share_table = Vector.fromList
  [C "!" `:(bool -> bool) -> bool`, V "x" `:bool`, V "y" `:bool`,
   C "=" `:bool -> bool -> bool`, C "><" `:bool -> bool -> bool`,
   C "~" `:bool -> bool`]
  val DT = Thm.disk_thm share_table
  in
  val exclusive_or =
    DT("", [],
       `(%0 (\%1. (%0 (\%2. ((%3 ((%4 $1) $0)) (%5 ((%3 $1) $0)))))))`)
  end
  val _ = DB.bindl "xor" [("exclusive_or",exclusive_or,DB.Def)]
  
  
end
